use std::{io::{Read, Write}, net::TcpListener};

const PORT: usize = 10000;
const BUFF_SIZE: usize = 1;

fn main() -> std::io::Result<()> {

    let listener = TcpListener::bind(format!("0.0.0.0:{PORT}"))?;

    for stream in listener.incoming() {
        std::thread::spawn(move || {
            match stream {
                Ok(mut stream) => {
                    loop {
                        let mut buf: [u8; BUFF_SIZE] = [0; BUFF_SIZE];

                        if let Ok(_) = stream.read_exact(&mut buf) {
                            println!("{:?}", &buf);
                            let _ = stream.write(&buf);
                        } else {
                            break;
                        }
                    }
                },
                Err(e) => panic!("{:?}", e)
            }
        });
    }

    Ok(())
}
